// Associative array by participant ID
var resultData = new Object();

// 2-deep Associative array representing the co-occurence
// of category members.
var resultGrid = new Object();

function startupAnalysis() {
	loadDataFiles();
}

function loadDataFileNames() {
	resultData = new Object();
	resultGrid = new Object();
	var du=new DirUtils(); 
	var tempNode, tempCatName;
	var tempFile, tempFileName, tempLabel;
	var listbox = 		document.getElementById("participant-list");
	var dataPath = du.getChromeDir() + fileSeparator + 'uzcardsort' + fileSeparator + 'content' + fileSeparator + 'data' + fileSeparator + projectInfo.name + fileSeparator ;
	var dataFolder = new Dir(dataPath);
	dataFiles =dataFolder.readDir();	
	for(var i=0;i<dataFiles.length;i++) {
		tempFile = dataFiles[i];
		tempFileName = tempFile.path;
		tempLabel = tempFileName.replace('.xml', '');
		tempNode = document.createElement("listitem");
		tempNode.setAttribute("label", listLast(tempLabel, fileSeparator));
		listbox.appendChild(tempNode);
	}
}

function loadDataFiles() {
	resultData = new Array(1);
	var du=new DirUtils(); 
	var tempNode, tempCatName;
	var tempFile, tempFileName, tempLabel;
	var listbox = 		document.getElementById("participant-list");
	deleteAllChilds(listbox);
	var dataPath = du.getChromeDir() + fileSeparator + 'uzcardsort' + fileSeparator + 'content' + fileSeparator + 'data' + fileSeparator + projectInfo.name + fileSeparator ;
	var dataFolder = new Dir(dataPath);
	dataFiles =dataFolder.readDir();	
	for(var i=0;i<dataFiles.length;i++) {
		tempFile = dataFiles[i];
		tempFileName = tempFile.path;
		tempLabel = tempFileName.replace('.xml', '');
		tempNode = document.createElement("listitem");
		tempNode.setAttribute("label", listLast(tempLabel, fileSeparator));
		listbox.appendChild(tempNode);
		loadDataFile(tempFile.path);
		buildResultsGrid();
	}
}

function loadDataFile(dataPath) {
	dump("Pulling data for " + dataPath + "\n");
	var tempName, xmlData, categoryNodes, tempCat, tempLabel;
	
	var dataID = listLast(dataPath, fileSeparator);
	var categoryObject;
	dataID = dataID.replace('.xml', '');
	resultData[dataID]= new Object();
	dataFile = new File(dataPath);
	dataFile.open("r");
	xmlData = dataFile.read();
	dataFile.close();
	dump("Data file read, storing to " + dataID + "\n");
	resultDOM = new DOMParser().parseFromString(xmlData, "text/xml");
	categoryNodes = resultDOM.getElementsByTagName("category");
	dump("Found classifications for " + categoryNodes.length + "\n");
	for(var i=0;i<categoryNodes.length;i++) {
		dump("Category holder " + i + "\n");
		tempCat = categoryNodes.item(i);
		tempName = tempCat.getAttribute("label");
		if(!tempName.length) tempName = "cat" + i;
		dump("Adding key of " + tempName + "\n");
		resultData[dataID][tempName] =new Object();
		categoryObject = resultData[dataID][tempName];
		categoryObject.values = '';
		
		for(var j=0; j<tempCat.childNodes.length;j++) {
			dump("Classification " + j + "\n");
			// Only add a comma for non-first items
			tempLabel = tempCat.childNodes.item(j).getAttribute("label");
			if(categoryObject.values.length) categoryObject.values = categoryObject.values + ',';
			categoryObject.values = categoryObject.values + tempLabel;
		}
		dump(categoryObject.values + " is the set \n");
	}	
}

function showUserData(userID) {
	dump("Show user classification \n");
	if(!userID) {
	var tempLabel =document.getElementById("participant-list").selectedItem.getAttribute("label");
	} else {
		tempLabel = userID;
	}
	dump("Got label " + tempLabel + " and " + resultData[tempLabel] + "\n");
	var htmlView = document.getElementById("html-user-view").contentDocument.body;
	var tempString = '';
	for(i in resultData[tempLabel]) {
		userResults = resultData[tempLabel][i].values;
		dump("Looking at " + i + " for " + tempLabel + " with list" + userResults + "\n");
		tempString = tempString + "<h1>" + i + "</h1>";
		var arUserResults = userResults.split(",");
		dump(arUserResults.length + " in the cat \n");
		for(j=0; j<arUserResults.length;j++) {
			dump("Mapping " + arUserResults[j] + "\n");
			tempString += "<a href=\"javascript:parent.showClassifications('" + arUserResults[j] +"','" + tempLabel +  "');\">" + arUserResults[j]  + "</a><br/>";
		}
	}
	//dump(tempString + "\n" + " is going to " + htmlView.nodeName + " with " + htmlView.innerHTML + "\n");
	htmlView.innerHTML = tempString;
	//dump("\n\ninnerhtml is " + htmlView.innerHTML + "\n");

}

function buildResultsGrid() {
	dump("\n\nBuilding results by item \n\n")
	for(tempLabel in resultData) {
		dump("$$$ " + tempLabel + ".");
		//tempLabel = resultData[h]

		for(i in resultData[tempLabel]) {
			//dump("i is " + i + " with values " + resultData[tempLabel][i].values + ".");
			userResults = resultData[tempLabel][i].values;
			var arUserResults = userResults.split(",");
			dump(arUserResults.length + " in the cat, ");
			for(j=0; j<arUserResults.length;j++) {
				if(!resultGrid[arUserResults[j]]) { 	
					resultGrid[arUserResults[j]] = new
 Object();
					}
				for(k=0; k<arUserResults.length;k++) {
			if( !resultGrid[arUserResults[j]][arUserResults[k]] ) {
					resultGrid[ arUserResults[j]][arUserResults[k] ] =1;

				} else {
					resultGrid[ arUserResults[j]][arUserResults[k]]++;
				}
			}
		}
	}
	}
	dump("\nResultGrid\n")
	for(i in resultGrid) {
		dump(i + "::")
		for( j in resultGrid[i]) dump(j + " with " + resultGrid[i][j] + ", ");
		dump("\n");
	}
}

function showClassifications(catLabel,backTo) {
	var htmlView = document.getElementById("html-user-view").contentDocument.body;
	dump("\n\nShowing Classifications for " + catLabel + "\n\n");
	var resultSet = resultGrid[catLabel];
	for(var j in resultSet) dump("rs " + j + " ");
	tempString = '<h1>' + catLabel + ' Grouping Count</h1>';
	for(i in resultSet) {
		tempString += resultSet[i] + " " + i + "<br/>";
		
	}
	tempString += "<br/><br/><a href=\"javascript:parent.showUserData('" + backTo + "');\">back to user" + backTo + "</a>";
	dump("html is " + tempString + "\n");
	htmlView.innerHTML = tempString;
	
}

function populateMatrix() {
	var grid = document.getElementById("");
	
}

